var header_height = 61;
var tabs_height = 37;
var footer_height = 26;
var total_set_height = header_height + tabs_height + footer_height;



function setSize() {

}


//---------------------------------------------------------------------------------------------
$(document).ready(function () {
	'use strict';


	$(".tab").hover(
		function () {
			var statusdiv = document.getElementById('tabdesc');
			if (this.id === "tabhtml5") {
				statusdiv.innerHTML = "A set of example HTML5 tests";
			}
			if (this.id === "tabjava") {
				statusdiv.innerHTML = "A set of example Java tests";
			}
			if (this.id === "tabmonitor") {
				statusdiv.innerHTML = "A list of available monitoring plugins";
			}
			if (this.id === "tabanalysis") {
				statusdiv.innerHTML = "Reporting and Analysis for test data";
			}
			if (this.id === "tabsat") {
				statusdiv.innerHTML = "Deploy and review Satellites";
			}
			if (this.id === "qap") {
				statusdiv.innerHTML = "Global Quality Assessment Points";
			}
			if (this.id === "tabhelp") {
				statusdiv.innerHTML = "Help and tutorials for MCS";
			}
		},
		function () {
			var statusdiv = document.getElementById('tabdesc');
			statusdiv.innerHTML = "";
		}
	);

	$(".tabadmin").hover(
		function () {
			var statusdiv = document.getElementById('tabdesc');
			statusdiv.innerHTML = "Administration Panel";
		},
		function () {
			var statusdiv = document.getElementById('tabdesc');
			statusdiv.innerHTML = "";
		}
	);

	$(".tabadmin").click(function () {
		var status = $('#' + this.id + "panel").css('display');
		if (status === "none") {
			$('#tabadmin').addClass('adminselected');

		} else {
			$('#tabadmin').removeClass('adminselected');
		}
		$('#' + this.id + "panel").animate({
			width: 'toggle',
		}, 550, function () {});

	});

	$(".help_image").click(function () {
		$('#' + this.id + '_data').slideToggle();
	});

});
//---------------------------------------------------------------------------------------------
function gup(name) {
	'use strict';
	name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
	var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
		results = regex.exec(location.search);
	return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

//---------------------------------------------------------------------------------------------
String.prototype.trim = function () {
	'use strict';
	return this.replace(/^\s+|\s+$$/g, "");
};

function swoBack() {
	'use strict';
	var refer = document.referrer;
	location.href = refer;
}

//---------------------------------------------------------------------------------------------
function $$(element) {
	'use strict';
	if (arguments.length > 1) {
		for (var i = 0, elements = [], length = arguments.length; i < length; i++) {
			elements.push($$(arguments[i]));
		}
		return elements;
	} else {
		return document.getElementById(element);
	}
}
//---------------------------------------------------------------------------------------------
function doJumpTo() {
	'use strict';
	var ele = document.getElementById("jumpto");
	if (ele) {
		var page = ele.options[ele.selectedIndex].value;
		if (page.length > 0) {
			window.location = page;
		}
	}
}
//---------------------------------------------------------------------------------------------
function show(id) {
	'use strict';
	setSize();
	var ele = document.getElementById(id);
	if (ele) {
		ele.style.display = (ele.style.display === "none") ? "" : "none";
	}
}
//--------------------
Object.size = function (obj) {
	var size = 0,
		key;
	for (key in obj) {
		if (obj.hasOwnProperty(key)) size++;
	}
	return size;
};
//---------------------------------------------------------------------------------------------
function mcs_showAll(id) {
	var eles = document.getElementsByName(id);
	for (var jj = 0; eles && jj < eles.length; jj++) {
		eles[jj].style.display = (eles[jj].style.display === "none") ? "" : "none";
		if (jj === 0) {
			addIdToCheckboxStr(id, eles[jj].style.display);
		}
	}
}
//---------------------------------------------------------------------------------------------
function isCookiePresent(ck) {
	if (document.cookie.indexOf(ck) >= 0) {
		return true;
	} else {
		return false;
	}
}
//---------------------------------------------------------------------------------------------
function checkCbCookie() {
	if (isCookiePresent('cbstates')) {
		checkboxstates = parseStrToObjArray(getCookie("cbstates")); //parse cookies if present
		//console.log(checkboxstates);
		var cbsize = Object.size(checkboxstates); //size of array
		if (cbsize > 0) { //if the array has entries
			var cbkeys = Object.keys(checkboxstates); //Get the key values for the array
			for (var ca = 0; ca < cbsize; ca++) { //cycle through each checkbox array entry
				var cb_eles = document.getElementsByName(cbkeys[ca]); //get all the element names for the ID
				var cb_state = checkboxstates[cbkeys[ca]]; //get state none or ''
				updateCheckBox(cbkeys[ca], cb_state);
				for (var ce = 0; ce < cb_eles.length; ce++) { //cycle through each element name
					cb_eles[ce].style.display = cb_state;
				}
			}
		}
	}
}

//----------------------------------------
function updateCheckBox(id, state) {
	if (document.getElementById(id + '_cb') !== null) {
		if (state === "") {
			document.getElementById(id + '_cb').checked = true;
		} else {
			document.getElementById(id + '_cb').checked = false;
		}
	}
}

function parseStrToObjArray(str) {
	return JSON.parse(str);
}

//---------------------------------------------------------------------------------------------
function addIdToCheckboxStr(id, state) {
	checkboxstates['' + id + ''] = state; //add state for id. checkboxstates defind in actstatus.html
}

//---------------------------------------------------------------------------------------------
function mcs_toggle(el) {
	'use strict';
	var ele = document.getElementById(el);
	var pic = document.getElementById(el + "icon");
	var txt = document.getElementById(el + "txt");
	if (ele.style.display === "none") {
		ele.style.display = "";
		if (pic) {
			pic.src = "/myspeed/minus.gif";
		}
		if (txt) {
			txt.innerHTML = "Hide" + txt.innerHTML.substring(4);
		}
	} else {
		ele.style.display = "none";
		if (pic) {
			pic.src = "/myspeed/plus.gif";
		}
		if (txt) {
			txt.innerHTML = "Show" + txt.innerHTML.substring(4);
		}
	}
}
//---------------------------------------------------------------------------------------------
function mcs_selectListItem(box, val) {
	'use strict';
	for (var ii = 0; ii < box.options.length; ii++) {
		if (box.options[ii].value === val) {
			box.selectedIndex = ii;
			break;
		}
	}
}
//---------------------------------------------------------------------------------------------
function mcs_showPopup(file, width, height) {
	'use strict';
	window.open(file, "popup", "width=" + width + ",height=" + height + ",fullscreen=0,statusbar=yes,scrollbars=yes,resizable=yes");
}
//---------------------------------------------------------------------------------------------
function mcs_getPopup(file, width, height) {
	'use strict';
	return window.open(file, "popup", "width=" + width + ",height=" + height + ",fullscreen=0,statusbar=yes,scrollbars=yes,resizable=yes");
}
//---------------------------------------------------------------------------------------------
function mcs_getScrollPos() {
	'use strict';
	var nRet = document.body.scrollTop;
	if (nRet === 0) {
		if (window.pageYOffset) {
			return window.pageYOffset;
		} else {
			return (document.body.parentElement) ? document.body.parentElement.scrollTop : 0;
		}
	} else {
		return nRet;
	}
}
//---------------------------------------------------------------------------------------------
function mcs_getEventPos(e, hit, relativeTo) {
	'use strict';
	var hitpos;
	if (document.layers) {
		return new Array(e.layerX, e.layerY);
	} else if (document.all) {
		hitpos = mcs_getPosition(hit, relativeTo);
		return new Array(event.clientX - hitpos[0], event.clientY - hitpos[1]);
	} else if (document.getElementById) {
		hitpos = mcs_getPosition(hit, null);
		return new Array(e.pageX - hitpos[0], e.pageY - hitpos[1]);
	}
}
//-----------------------------------------------------------------------------------------
function mcs_getPosition(ele, relativeTo) {
	'use strict';
	relativeTo = (relativeTo === null) ? null : relativeTo.offsetParent;
	var x = 0;
	var y = 0;
	while (ele && ele !== relativeTo) {
		x += ele.offsetLeft;
		y += ele.offsetTop;
		ele = ele.offsetParent;
	}
	return new Array(x, y);
}
//-----------------------------------------------------------------------------------------
function mcs_selectTab(tabName) {
	'use strict';
	window.location.href = "/myspeed/admin?tb=" + tabName;
}

//-----------------------------------------------------------------------------------------
function mcs_customTab(tabName) {
	'use strict';

	var tabs = new Array("testing", "monitoring");
	for (var ii = 0; ii < tabs.length; ii++) {
		var tab = document.getElementById("tab" + tabs[ii]);
		var tabtxt = document.getElementById("tabtxt" + tabs[ii]);
		var tabcont = document.getElementById("tabcont" + tabs[ii]);
		if (tab && tabtxt && tabcont) {
			tab.className = (tabs[ii] === tabName) ? "tab livetab" : "tab";
			tabtxt.className = (tabs[ii] === tabName) ? "tabtxt livetxt" : "tabtxt";
			tabcont.style.display = (tabs[ii] === tabName) ? "block" : "none";
		}
	}
}

//---------------------------------------------------------------------------------------------


// JavaScript from serversetup page
function testemail() {
	'use strict';
	mcs_showPopup('/myspeed/admin/testemail', 450, 250);
	var frm = document.getElementById("frm");
	var redir = document.getElementById("redir");
	if (redir) {
		redir.value = "/myspeed/admin/serversetup";
	}
	if (frm) {
		frm.submit();
	}
}

function toggle(el) {
	'use strict';
	var ele = document.getElementById(el);
	var pic = document.getElementById(el + "icon");
	if (ele.style.display == "none") {
		ele.style.display = "block";
		pic.src = "/myspeed/minus.gif";
	} else if (ele.style.display == "block") {
		ele.style.display = "none";
		pic.src = "/myspeed/plus.gif";
	}
}

function enableSection(el) {
	'use strict';
	var ele = document.getElementById(el);
	var enable = true;
	if (ele.style.color == "#000000" || ele.style.color.toString() == "rgb(0, 0, 0)") {
		//disable
		enable = false;
	}
	ele.style.color = (enable) ? "#000000" : "#666666";
}

function initChecks() {
	'use strict';
	if ("" != "checked") enableSection('throttledelay');
	if ("" != "checked") enableSection('throttleradelay');
	if ("" != "checked") enableSection('dlimitusers');

	capacityInit();

	conferenceInit();

	firewallInit();

	speedInit();

	iptvInit();

	speedInit();

	videoInit();

	voipInit();

}

function capacityInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('capacityports');
	}
}

function conferenceInit() {
	'use strict';
	mcs_selectListItem(document.getElementById("conferencethreadtimeout"), "20000");
	if ("checked" !== "checked") {
		enableSection('conferenceports');
	}
}

function firewallInit() {
	'use strict';
	mcs_selectListItem(document.getElementById("firewallthreadtimeout"), "20000");
	if ("checked" !== "checked") {
		enableSection('firewallports');
	}
}

function speedInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('sockettestports');
	}
}

function iptvInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('iptvports');
	}
}

function speedInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('sockettestports');
	}
}

function videoInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('videoports');
	}
}

function voipInit() {
	'use strict';
	if ("checked" !== "checked") {
		enableSection('voipports');
	}
}

function valDbChanges() {
	document.getElementById('sub_err').innerHTML = "";
	var db_cu = valDbCleanup();
	var db_be = checkBackend();
	if (db_cu === false || db_be === false) {
		return false;
	} else {
		return true;
	}
}

function valDbCleanup() {
	var dbdd = parseInt(document.getElementById('dbdd').value);
	var dbd = parseInt(document.getElementById('dbd').value);
	var dbcd = parseInt(document.getElementById('dbcd').value);
	if (dbdd === 0 || dbd === 0 || dbcd === 0) {
		document.getElementById('sub_err').innerHTML += "0 is not a valid Database Cleanup value. Please use -1 to keep data indefinitely or a number higher than 0.<br>";
		return false;
	} else {
		return true;
	}
}

function isValidHost(host) {
	if (host !== "") {
		if (!/^([a-z0-9][a-z0-9-]*[a-z0-9]\.)+[a-z]{2,}$/.test(host)) {
			return false;
		} else {
			return true;
		}
	} else {
		return true;
	}
}

function isValidIp(ip) {
	if (ip !== "") {
		var x = ip.toString().split('.'),
			x1, x2, x3, x4;
		if (x.length === 4) {
			x1 = parseInt(x[0], 10);
			x2 = parseInt(x[1], 10);
			x3 = parseInt(x[2], 10);
			x4 = parseInt(x[3], 10);
			if (isNaN(x1) || isNaN(x2) || isNaN(x3) || isNaN(x4)) {
				return false;
			}
			if ((x1 >= 0 && x1 <= 255) && (x2 >= 0 && x2 <= 255) && (x3 >= 0 && x3 <= 255) && (x4 >= 0 && x4 <= 255)) {
				return true;
			}
		} else {
			return false;
		}
	} else {
		return true;
	}
}

function checkBackend() {
	var sBackend = document.getElementById("backendserver").value;
	var sBePw = document.getElementById("backendserverpass").value;
	if (!isValidIp(sBackend) && !isValidHost(sBackend)) {
		document.getElementById('sub_err').innerHTML += "The backend server host isn't valid. Please set a valid IP or host name.<br>";
		return false;
	} else if (sBePw.length === 0 && sBackend.length > 0) {
		document.getElementById('sub_err').innerHTML += "A password needs to be set for the backend server.<br>";
		return false;
	} else {
		return true;
	}

}

// END END END
